#ifndef n_cFileKeeper_H
#define n_cFileKeeper_H

/*
 *
 * nucleo/core/carbon/cFileKeeper.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/core/FileKeeper.H>

#include <Carbon/Carbon.H>

namespace nucleo {

  // ---------------------------------------------------------------

  class cFileKeeper : public FileKeeper {

  protected:

    CFOptionFlags _flags ;
    CFSocketRef _cfSocket ;
    CFRunLoopSourceRef _cfRunLoopSource ;

    EventLoopTimerRef _timerId ;

    friend class FileKeeper ;

    cFileKeeper(void) ;
    void _cleanup(void) ;
    static void _callback(CFSocketRef s,
					 CFSocketCallBackType type,
					 CFDataRef address, const void *data, void *info) ;

    static void _callback2(EventLoopTimerRef timerId, void *data) ;

  public:

    ~cFileKeeper(void) ;

    void setup(int fd, eventMask mask) ;

  } ;

  // ---------------------------------------------------------------

}

#endif
