#ifndef n_qtMovImageSink_H
#define n_qtMovImageSink_H

/*
 *
 * nucleo/image/sink/qtMovImageSink.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/image/sink/ImageSink.H>
#include <nucleo/core/URI.H>

#include <Carbon/Carbon.h>
#include <QuickTime/QuickTime.h>

#include <string>

namespace nucleo {

  class qtMovImageSink : public ImageSink {

  private:

    std::string _filename ;
    CodecType _codec ;

    Movie _movie ;
    Track _track ;
    Media _media ;
    short _resRefNum ;
    TimeValue _framerate ;
    
    Image _img ;

    enum { BEZERK, OPENED, CLOSED } _state ;

  public:

    qtMovImageSink(const URI &u) ;
    ~qtMovImageSink() ;

    bool start(void) ;
    bool handle(Image *img) ;
    bool isActive(void) ;
    bool stop(void) ;
    
  } ;

}

#endif
